# =====================================================================
# grant.awk: RPC I/O functions for example.grant
#
# Copyright (c) 2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or   
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License   
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================

# =====================================================================
# int _invar(string name, string value)
#
# Input hooks *must* always write rc(1) statements to CSA_RPC_WWW.
# =====================================================================

function _invar(name,value,		ofile, pw_len, nick) {

   # Make local copies, especially of those vars that we
   # will need to modify.

   ofile = ENVIRON["CSA_RPC_WWW"]

   # Check for valid password syntax.

   if (name == "WWW_password") {
      pw_len = length(value)

      if (value !~ /^[-+_a-zA-Z0-9@.!]*$/ || \
	 (pw_len < 6 || pw_len > 12))
		print "csaExit.fault 0041 password" >> ofile
      else return(_rcassign("CSA_AUTH_PW",value,ofile))
   }

   # Check for valid userid syntax.

   else if (name == "WWW_userid") {
      # remove any surrounding blanks.
      nick = _strip(value)
      if (value !~ /^[a-z][a-z][-_a-z0-9@.]*$/)
		print "csaExit.fault 0041 userid" >> ofile
      else {
	 printf("CSA_AUTH_PBC=%s/%s\n",\
		substr(value,1,1), substr(value,2,1)) >> ofile
      	 return(_rcassign("CSA_AUTH_USER",value,ofile))
      }
   }

   return 0				# Ignore unknown arguments.
}

# =====================================================================
# string _outvar(string name, string value)
#
# Default output variable post-processing hook. Simply returns the
# passed argument value unchanged.
# =====================================================================

function _outvar(name,value) {

   return value
}

# EOF
