# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2002,2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _formtext.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# string _formtext(string name, string value, \
#				int size, int maxsize, boolean pass)
#
# Returns the proper HTML "text" form fragment, based on the specified
# arguments. Warning: the "value" string is not automatically
# XML-encoded. If such an encoding is desired it is up to the calling
# program to do it before calling this function. This is also to
# save processing, as the caller may want to encode the text only once
# for values that are needed in several places. If the last argument
# is "0" or _NULL, then a normal input field is returned, otherwise
# the result will be a "password" type input field. If size/maxsize
# are _NULL or "0" then they will be ignored.
# =====================================================================

function _formtext(name,value,size,max,pass,		fragment) {

  if (pass) fragment = "<input type=\"password\" name=\"" name "\""
  else fragment = "<input type=\"text\" name=\"" name "\""

  size += 0; max += 0			# Cast to numbers.

  if (size) fragment = fragment " size=\"" size "\""
  if (max) fragment = fragment " maxsize=\"" max "\""

  fragment = fragment " value=\"" value "\">"

  return fragment
}

