# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2002,2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _formarea.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# string _formarea(string name, string value, int cols, int rows)
#
# Returns the proper HTML "textarea" form fragment, based on the
# specified arguments. Warning: the "value" string is not automatically
# XML-encoded. If such an encoding is desired it is up to the calling
# program to do it before calling this function.
# =====================================================================

function _formarea(name,value,cols,rows,		fragment) {

  fragment = "<textarea name=\"" name "\""

  cols += 0; rows += 0				# Cast to numbers.

  if (cols) fragment = fragment " cols=\"" cols "\""
  if (rows) fragment = fragment " rows=\"" rows "\""

  fragment = fragment ">" value "</textarea>"

  return fragment
}

