# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2002,2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _isodate.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# string _isodate(string local_date)
#
# Takes a date string, in the local format, and returns the corresponding
# ISO format "YYYY-mm-dd 00:00:00". No checks are done to make sure that
# the specified date is a valid one. The input date string is interpreted
# based on CSA_LANG.
# =====================================================================

function _isodate(date,				iso_date, token) {

  iso_date = _strip(date)
  if (iso_date == _NULL) return _NULL

  if (split(date, token, /[-\/ :.]/) != 3) return _NULL

  if (ENVIRON["CSA_LANG"] != "en_US") {
     iso_date = token[3] "-" token[2] "-" token[1] " 00:00:00"
  }
  else {						# Default is "en_US"
     iso_date = token[3] "-" token[1] "-" token[2] " 00:00:00"
  }
  return iso_date
}

